#include <bits/stdc++.h>
using namespace std;

int a[1000000];
int b[1000000];

int main()
{
    int n;
    cin >> n;
    for(int i = 0; i < n; i++)
    {
        cin >> a[i];
        b[i] = a[i];
    }
    if(n == 1)
    {
        cout << a[0];
        return 0;
    }
    sort(b, b + n, greater<int>());
    bool iste = false;
    int br = -1, ind = -1;
    for(int i = 0; i < n; i++)
    {
        if(i != 0)
        {
            if(b[i - 1] == b[i])
                iste = true;
        }
        if(b[i] != a[i])
        {
            ind = i;
            br = b[i];
            break;
        }
    }

    int pom;
    if(br == -1)
    {
        if(!iste)
        {
            pom = a[n - 1];
            a[n - 1] = a[n - 2];
            a[n - 2] = pom;
            for(int i = 0; i < n; i++)
                cout << a[i] << " ";
        }
        else
        {
             for(int i = 0; i < n; i++)
                cout << a[i] << " ";
        }

        return 0;
    }
    for(int i = n - 1; i >= 0; i--)
    {
        if(a[i] == br)
        {
            pom = a[i];
            a[i] = a[ind];
            a[ind] = pom;
            break;
        }
    }
    for(int i = 0; i < n; i++)
        cout << a[i] << " ";

}